您的位置:首页 > 产品设计 > UI/UE

LeetCode(62)Unique Paths

2015-09-11 21:01 459 查看

题目

A robot is located at the top-left corner of a m x n grid (marked ‘Start’ in the diagram below).

The robot can only move either down or right at any point in time. The robot is trying to reach the bottom-right corner of the grid (marked ‘Finish’ in the diagram below).

How many possible unique paths are there?



Note: m and n will be at most 100.

分析

这是一道动态规划的题目:

对于一个m∗nm*n矩阵,求解从初始点(0,0)(0,0)到结束点(m−1,n−1)(m-1,n-1)的路径条数,规定每次只能向右或向下走一步;

我们知道:

1.当i=0,j=[0,n−1]i=0 , j=[0,n-1]时,f(i,j)=f(i,j−1)=1f(i,j) = f(i,j-1) = 1; 因为每次只能向右走一步,只有一条路径;

2. 当i=[0,m−1],j=0i=[0,m-1] , j=0时,f(i,j)=f(i−1,j)=1f(i,j) = f(i-1 , j) = 1;因为每次只能向下走一步,只有一条路径;

3. 当(i,j)(i,j)为其它时,f(i,j)=f(i−1,j)+f(i,j−1)f(i,j) = f(i-1,j)+f(i,j-1);因为此时可由(i−1,j)(i-1,j)向右走一步,或者(i,j−1)(i,j-1)向下走一步,为两者之和;

AC代码

//非递归实现回溯,会超时
class Solution {
public:
int uniquePaths(int m, int n) {
if (m == 0 || n == 0)
return 0;
vector<vector<int> > ret(m, vector<int>(n, 1));
//如果矩阵为单行或者单列,则只有一条路径
for (int i = 1; i < m; i++)
for (int j = 1; j < n; j++)
ret[i][j] = ret[i - 1][j] + ret[i][j - 1];

return ret[m-1][n-1];
}
};


递归实现算法(TLE)

class Solution {
public:
int uniquePaths(int m, int n) {
if (m == 0 || n == 0)
return 0;
//如果矩阵为单行或者单列,则只有一条路径
else if (m == 1 || n == 1)
return 1;

else
return uniquePaths(m, n - 1) + uniquePaths(m - 1, n);
}
};


GitHub测试程序源码
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: